const ObjectUtils = {};

ObjectUtils.deepCopy = (obj) => {
  return JSON.parse(JSON.stringify(obj));
};

// deepCopy
ObjectUtils._deepCopy = (data) => {
  const t = typeOf(data);
  let o;

  if (t === 'array') {
    o = [];
  } else if ( t === 'object') {
    o = {};
  } else {
    return data;
  }

  if (t === 'array') {
    for (let i = 0; i < data.length; i++) {
      o.push(ObjectUtils._deepCopy(data[i]));
    }
  } else if ( t === 'object') {
    for (let i in data) {
      o[i] = ObjectUtils._deepCopy(data[i]);
    }
  }
  return o;
}

ObjectUtils.isEmpty = (obj) => {
  // 本身为空直接返回true
  if (obj === null || obj === undefined) return true;

  // 然后可以根据长度判断，在低版本的ie浏览器中无法这样判断。
  if (obj.length > 0) {
    return false;
  }
  if (obj.length === 0) {
    return true;
  }

  // 最后通过属性长度判断。
  for (var key in obj) {
    if (hasOwnProperty.call(obj, key)) return false;
  }

  return true;
};

export default ObjectUtils;
